#debug "Shot eight is being parsed.\n"

#declare CamE=<0,68,-700>;
#declare CamL=<200,200,25>+<-200,-132,-675>/40*Timer;

#declare BSOD=min(max((Timer-3),0),1);

#include "gulch.inc"

#declare PathPts=array[8] {
  <100,0,-650>,vnormalize( x+z),
  <100,0,-350>,vnormalize(-x+z),
  <-50,0,-400>,vnormalize(-x-2*z),
  <-50,0,-500>,vnormalize( x-3*z)
}

#declare Path=array[4][5]

PrepFullSpline(PathPts,Path)

#local i_M=vdot(Path[2][4],x+y);
#debug concat("Path length ",str(i_M,0,4),"\n")

#local i_I=Transition(0,i_M,0,(Timer-.5)/2.5);

#declare BoxerZ=vnormalize(SplineVel(Path,i_I));
#declare BoxerY=y;
#declare BoxerX=vnormalize(vcross(BoxerY,BoxerZ));
#declare BoxerL=SplineLoc(Path,i_I);
#declare BoxerEyeL=<-50,100,481>;
#declare BoxerEyeR=<-50,100,481>;
#declare BoxerHandL=<-15,40,45>;
#declare BoxerHandR=< 15,40,45>;
#declare BoxerWristL=0;
#declare BoxerWristR=0;
#declare BoxerClawL=15;
#declare BoxerClawR=15;
#declare FootL=<-14,0,21>;
#declare FootR=< 14,0, 8>;
#declare WheelSpin=i_I*360/2/pi/10;
#declare WheelTurn=0;
#declare GateClip=false;
#declare DoorOpen=1;
#declare LaserUp=1;
#declare LaserOn=0;
#if(Timer>2.999) #declare LaserOn=1; #end
#if(Timer>3.499) #declare LaserOn=0; #end

#local pS=<0,0,-500>+880*vnormalize(<-2,0,5>);
#local pS=vm_invert(pS,vnormalize(x-z),y,vnormalize(x+z),<100,0,-650>);
#local pS=BoxerL+pS.x*BoxerX+55*BoxerY+pS.z*BoxerZ;
#declare Target=Transition(pS,<0,115,-1720>,0,(Timer-2.5)*2);
#declare LaserAimed=0;
#include "boxer.inc"

#declare PortX=-x;
#declare PortY=y;
#declare PortZ=-z;
#declare PortL=<0,0,1400>;
#declare PortOpen=1;
#include "port.inc"

#local i_I=804.6;

#declare RobotY=y;
#declare RobotZ=-z;
#declare RobotX=-x;
#declare RobotL=<50,0,-500>;
#declare RotLT=i_I*180/pi/5.625/sqrt(2+sqrt(3));
#declare RotRT=i_I*180/pi/5.625/sqrt(2+sqrt(3));
#declare CamLft1=0;
#declare CamSwp1=0;
#declare CamLft2=15;
#declare CamSwp2=0;
#declare CamLft3=15;
#declare CamSwp3=-180;
#declare BotHandDir=z;
#declare BotHandLoc=<0,100,25>;
#declare ClawOpen=5;
#declare PortClip=false;
#if (Test=0) #include "rusty.inc" #end        

